#ifndef CoCoA_TmpMorsePaths_H
#define CoCoA_TmpMorsePaths_H

#include "CoCoA/TmpMorseElement.H"
#include <map>


namespace CoCoA
{

  class MorsePaths;

  typedef std::map<MorseElement, MorsePaths>::const_iterator ConstResIter;

  struct MorseIterCompare
  {
    bool operator()(const ConstResIter lhs, const ConstResIter rhs);
  };

  typedef std::map<ConstResIter, RingElem, MorseIterCompare> PathMap;

  class MorsePaths
  {
  private:
    //basic datastructure
    PathMap myPaths;

  public:
    MorsePaths(): myPaths() {}

    // Return all paths.
    inline const PathMap& myGetPaths() const { return myPaths; }

    // Add to the path with origin m the RingElem elem.
    // If there is no path from m, we add a new path.
    void myAddPath(const ConstResIter& m, const RingElem& elem);

    // Test if there are any paths.
    inline bool IamEmpty() const { return myPaths.empty(); }

    // Return the path from MorseElement m.
    // WARNING!! This function does not work if we are in the betti case!!!
    inline ConstRefRingElem myGetPath(const ConstResIter& m)
    {
      const PathMap::iterator iter(myPaths.find(m));
      if (iter == myPaths.end())
      {
        return zero(owner((m->first).myGetBasisElement()));
      }
      return iter->second;
    }
  };


} // end of namespace CoCoA

#endif
